package com.xc.utils;

import com.xc.utils.enumUtil.IndexEnum;
import com.xc.utils.enumUtil.ResolutionEnum;

import java.text.SimpleDateFormat;
import java.util.Calendar;
import java.util.Date;

public class IndexDbCreatedUtil {

    private static final String decollator = "_";

    public static String createdDbTableName(String indexCode, String yearMonth, String resolution){
        StringBuilder sb = new StringBuilder("data").append(decollator).append(ResolutionEnum.getDbNameByCode(resolution)).append(decollator);
        String dbName = IndexEnum.getDbNameByCode(indexCode);
        sb.append(dbName).append(decollator).append(yearMonth);
        return sb.toString();
    }

    public static String createdDbTableNameByTime(String dbName, Date time){
        StringBuilder sb = new StringBuilder("data").append(decollator).append("rt").append(decollator);
        sb.append(dbName).append(decollator).append(getTimeString(time));
        return sb.toString();
    }

    public static String createdDbTableName(String indexCode, Date time){
        StringBuilder sb = new StringBuilder("data").append(decollator).append("rt").append(decollator);
        String dbName = IndexEnum.getDbNameByCode(indexCode);
        sb.append(dbName).append(decollator).append(getTimeString(time));
        return sb.toString();
    }

    public static String createdHistDbTableName(String indexCode){
        StringBuilder sb = new StringBuilder("data").append(decollator).append("hist").append(decollator);
        String dbName = IndexEnum.getDbNameByCode(indexCode);
        sb.append(dbName);
        return sb.toString();
    }

    // 获取年月
    public static int getYearMonth(Date time){
        return Integer.valueOf(getTimeString(time));
    }

    private static String getTimeString(Date time){
        String str = "yyyy";
        SimpleDateFormat sdf = new SimpleDateFormat(str);
        if(null != time){
            return sdf.format(time);
        }
        return sdf.format(new Date());
    }
}
