package com.xc.utils.enumUtil;


import com.xc.pojo.IndexInfo;

import java.util.ArrayList;
import java.util.List;

public enum IndexEnum {
    /**
     *
     */
    HSI_HI("HSI.HI", "HSI.HI", "恒生货币", "HSI_HI", "index"),
    GDAXI_GI("GDAXI.GI", "GDAXI.GI", "德国DAX", "GDAXI_GI", "index"),
    DJIA_GI("DJIA_GI", "DJIA_GI", "道琼斯工业平均", "DJIA_GI", "index"),
    IXIC_GI("IXIC.GI", "IXIC.GI", "纳斯达克", "IXIC_GI", "index"),
    CHA50CFD("CHA50CFD", "CHA50CFD", "富时A50", "CHA50CFD", "index"),
    SH000001("000001.SH", "000001.SH", "上证货币", "000001_sh", "index"),
    SZ399001("399001.SZ", "399001.SZ", "深证成指", "399001_sz", "index"),
    SZ399006("399006.SZ", "399006.SZ", "创业扳指", "399006_sz", "index");

    private String code;

    private String enName;

    private String cnName;

    private String dbName;

    // 股票"stock",  货币"index"
    private String type;

    IndexEnum(String code, String enName, String cnName, String dbName, String type) {
        this.code = code;
        this.enName = enName;
        this.cnName = cnName;
        this.dbName = dbName;
        this.type = type;
    }

    public String getCode() {
        return code;
    }

    public void setCode(String code) {
        this.code = code;
    }

    public String getEnName() {
        return enName;
    }

    public void setEnName(String enName) {
        this.enName = enName;
    }

    public String getCnName() {
        return cnName;
    }

    public void setCnName(String cnName) {
        this.cnName = cnName;
    }

    public String getDbName() {
        return dbName;
    }

    public void setDbName(String dbName) {
        this.dbName = dbName;
    }

    public String getType() {
        return type;
    }

    public void setType(String type) {
        this.type = type;
    }

    public static String getDbNameByCode(String code) {
        String dbName = null;
        for (IndexEnum e : IndexEnum.values()) {
            if (code.equals(e.getCode())) {
                dbName = e.getDbName();
                break;
            }
        }
        return dbName;
    }

    // 根据类型返回列表
    public static List<String> getNameList(int type) {
        List<String> list = new ArrayList<>();
        for (IndexEnum e : IndexEnum.values()) {
            if (1 == type) {
                // 返回ID
                list.add(String.valueOf(e.getCode()));
            } else if (2 == type) {
                // 返回英文名
                list.add(e.getEnName());
            } else if (3 == type) {
                // 返回返回类型
                list.add(e.getType());
            }
        }
        return list;
    }

    // 根据类型返回列表
    public static IndexEnum getEnumList(String code) {
        IndexEnum indexEnum = null;
        for (IndexEnum e : IndexEnum.values()) {
            if (code.equals(String.valueOf(e.getCode()))) {
                indexEnum = e;
                return indexEnum;
            }
        }
        for (IndexEnum e : IndexEnum.values()) {
            if (code.equals(e.getEnName())) {
                indexEnum = e;
                return indexEnum;
            }
        }
        return indexEnum;
    }

    // 根据类型返回列表
    public static List<IndexInfo> getList() {
        List<IndexInfo> list = new ArrayList<>();
        for (IndexEnum e : IndexEnum.values()) {
            IndexInfo indexInfo = new IndexInfo();
            indexInfo.setId(e.getCode());
            indexInfo.setEnName(e.getEnName());
            indexInfo.setCnName(e.getCnName());
            indexInfo.setDepositAmt(1000);
            indexInfo.setTransFee(50);
            list.add(indexInfo);
        }
        return list;
    }
}
